Package weka.core.converters

# Class SVMLightLoader

java.lang.Object
weka.core.converters.AbstractLoader
weka.core.converters.AbstractFileLoader
weka.core.converters.SVMLightLoader

All Implemented Interfaces:
  `Serializable`, `BatchConverter`, `FileSourcedConverter`, `Loader`, `URLSourcedLoader`, `EnvironmentHandler`, `RevisionHandler`

public class SVMLightLoader extends AbstractFileLoader implements BatchConverter, URLSourcedLoader
Reads a source that is in svm light format.
For more information about svm light see:
http://svmlight.joachims.org/

Version:
  $Revision: 4985 $
Author:
  FracPete (fracpete at waikato dot ac dot nz)
See Also:
  - `Loader`
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`static String`
`FILE_EXTENSION`
the file extension.

### Fields inherited from class weka.core.converters.AbstractFileLoader

`FILE_EXTENSION_COMPRESSED`

### Fields inherited from interface weka.core.converters.Loader

`BATCH, INCREMENTAL, NONE`

## Constructor Summary

Constructors
Constructor
Description
`SVMLightLoader()`

## Method Summary

Modifier and Type
Method
Description
`Instances`
`getDataSet()`
Return the full data set.
`String`
`getFileDescription()`
Returns a description of the file type.
`String`
`getFileExtension()`
Get the file extension used for svm light files.
`String[]`
`getFileExtensions()`
Gets all the file extensions used for this type of file.
`Instance`
`getNextInstance(Instances structure)`
SVMLightLoader is unable to process a data set incrementally.
`String`
`getRevision()`
Returns the revision string.
`Instances`
`getStructure()`
Determines and returns (if possible) the structure (internally the header) of the data set as an empty set of instances.
`String`
`globalInfo()`
Returns a string describing this Loader.
`static void`
`main(String[] args)`
Main method.
`void`
`reset()`
Resets the Loader ready to read a new data set.
`String`
`retrieveURL()`
Return the current url.
`void`
`setSource(InputStream in)`
Resets the Loader object and sets the source of the data set to be the supplied InputStream.
`void`
`setSource(URL url)`
Resets the Loader object and sets the source of the data set to be the supplied url.
`void`
`setURL(String url)`
Set the url to load from.

### Methods inherited from class weka.core.converters.AbstractFileLoader

`getUseRelativePath, retrieveFile, runFileLoader, setEnvironment, setFile, setSource, setUseRelativePath, useRelativePathTipText`

### Methods inherited from class weka.core.converters.AbstractLoader

`setRetrieval`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### FILE_EXTENSION

public static String FILE_EXTENSION
the file extension.

## Constructor Details

### SVMLightLoader

public SVMLightLoader()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this Loader.

Returns:
  a description of the Loader suitable for displaying in the explorer/experimenter gui

### getFileExtension

public String getFileExtension()
Get the file extension used for svm light files.

Specified by:
  `getFileExtension` in interface `FileSourcedConverter`
Returns:
  the file extension

### getFileExtensions

public String[] getFileExtensions()
Gets all the file extensions used for this type of file.

Specified by:
  `getFileExtensions` in interface `FileSourcedConverter`
Returns:
  the file extensions

### getFileDescription

public String getFileDescription()
Returns a description of the file type.

Specified by:
  `getFileDescription` in interface `FileSourcedConverter`
Returns:
  a short file description

### reset

public void reset() throws IOException
Resets the Loader ready to read a new data set.

Specified by:
  `reset` in interface `Loader`
Overrides:
  `reset` in class `AbstractFileLoader`
Throws:
  `IOException` - if something goes wrong

### setSource

public void setSource(URL url) throws IOException
Resets the Loader object and sets the source of the data set to be the supplied url.

Parameters:
  `url` - the source url.
Throws:
  `IOException` - if an error occurs

### setURL

public void setURL(String url) throws IOException
Set the url to load from.

Specified by:
  `setURL` in interface `URLSourcedLoader`
Parameters:
  `url` - the url to load from
Throws:
  `IOException` - if the url can't be set.

### retrieveURL

public String retrieveURL()
Return the current url.

Specified by:
  `retrieveURL` in interface `URLSourcedLoader`
Returns:
  the current url

### setSource

public void setSource(InputStream in) throws IOException
Resets the Loader object and sets the source of the data set to be the supplied InputStream.

Specified by:
  `setSource` in interface `Loader`
Overrides:
  `setSource` in class `AbstractLoader`
Parameters:
  `in` - the source InputStream.
Throws:
  `IOException` - if initialization of reader fails.

### getStructure

public Instances getStructure() throws IOException
Determines and returns (if possible) the structure (internally the header) of the data set as an empty set of instances.

Specified by:
  `getStructure` in interface `Loader`
Specified by:
  `getStructure` in class `AbstractLoader`
Returns:
  the structure of the data set as an empty set of Instances
Throws:
  `IOException` - if an error occurs

### getDataSet

public Instances getDataSet() throws IOException
Return the full data set. If the structure hasn't yet been determined by a call to getStructure then method should do so before processing the rest of the data set.

Specified by:
  `getDataSet` in interface `Loader`
Specified by:
  `getDataSet` in class `AbstractLoader`
Returns:
  the structure of the data set as an empty set of Instances
Throws:
  `IOException` - if there is no source or parsing fails

### getNextInstance

public Instance getNextInstance(Instances structure) throws IOException
SVMLightLoader is unable to process a data set incrementally.

Specified by:
  `getNextInstance` in interface `Loader`
Specified by:
  `getNextInstance` in class `AbstractLoader`
Parameters:
  `structure` - ignored
Returns:
  never returns without throwing an exception
Throws:
  `IOException` - always. SVMLightLoader is unable to process a data set incrementally.

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Returns:
  the revision

### main

public static void main(String[] args)
Main method.

Parameters:
  `args` - should contain the name of an input file.